-- config.lua
-- Apr 2017
-- Configuration Options
-- 
-- You should be able to leave most of the settings here as defaults.
-- The only thing you definitely want to change are the welcome messages.

--------------------------------------------------------------------------------
-- Messages
--------------------------------------------------------------------------------

WELCOME_MSG = "Welcome to Oarc Regrowth - Deadly Night, hosted by NFO Servers Admin by Philip017"
GAME_MODE_MSG = "Rocket Silo is already on the map. Trains RHD, signals outside. Very Low Oil. If you leave before 60 mins you will loose your base."
MODULES_ENABLED = "Beware the invading Bugs, as they will return to reclaim their lands."

WELCOME_MSG_TITLE = "Welcome to Oarc NFO Server. Join us on discord: discord.gg/KT64WHW"
WELCOME_MSG1 = "Rules: Be polite. Ask before changing other players's stuff. Have fun!"
WELCOME_MSG2 = "Blueprint Ghosts are automatically cleaned up, make sure you have the stuff before you build."

OTHER_MSG1 = "Repeaded connect and disconnect over a small time frame may get you banned."
OTHER_MSG2 = "Regrowth release, always beta testing."
-- Optional other messages below:
OTHER_MSG3 = "Regrowth mode will slowly delete unused portions of the map."
OTHER_MSG4 = "If you re-explore deleted parts of the map, resources will be in new locations."
OTHER_MSG5 = "If you leave before 60 minutes, your base will be deleted!"


WELCOME_MSG3 = "Due to the way this scenario works, it may take some time for the land"
WELCOME_MSG4 = "around your new spawn area to generate..."
WELCOME_MSG5 = "Its always twilight at half solar power, and there is no oil beyond your starting oil."
WELCOME_MSG6 = "Pending any major bugs, this map reset on Tuesday."

SPAWN_MSG1 = "Current Spawn Mode: HARDCORE WILDERNESS (BETA)"
SPAWN_MSG2 = "In this mode, there is no default spawn. Everyone starts in the wild!"
SPAWN_MSG3 = "Resources are spread out far apart but are quite rich."

-- These are my specific welcome messages that get used only if I am the user
-- that creates the game.
SERVER_OWNER_IS_OARC = false -- This should be false for you, it's just a convenience for me.
WELCOME_MSG_OARC = "Welcome to Oarc NFO server! Join the discord here: discord.gg/KT64WHW"
WELCOME_MSG_TITLE_OARC = "Welcome to Oarc NFO Server With Regrowth!"


--------------------------------------------------------------------------------
-- Module Enables
-- These enables are not fully tested! For example, disable separate spawns
-- will probably break the frontier rocket silo mode
--------------------------------------------------------------------------------

-- Frontier style rocket silo mode
FRONTIER_ROCKET_SILO_MODE = true

-- Separate spawns
-- This is the core of the mod. Probably not a good idea to disable it.
ENABLE_SEPARATE_SPAWNS = true

-- Enable Scenario version of RSO
-- You can reconfigure the RSO resource settings in the RSO files if you want to
ENABLE_RSO = true

-- Enable Undecorator
-- Removes decorative items to reduce save file size.
ENABLE_UNDECORATOR = true

-- Enable Tags
ENABLE_TAGS = true

-- Enable Long Reach
ENABLE_LONGREACH = true

-- Enable Autofill
ENABLE_AUTOFILL = true

-- Enable Playerlist
ENABLE_PLAYER_LIST = true

-- Enable Gravestone Chests
ENABLE_GRAVESTONE_ON_DEATH = false

 -- Items dumped into chest when you leave.
ENABLE_GRAVESTONE_ON_LEAVING = false
 -- If anyone leaves within first X minutes, items get dumped into chest.
ENABLE_GRAVESTONE_ON_LEAVING_TIME_MINS = 15

-- Enable quick start items
ENABLE_POWER_ARMOR_QUICK_START = true

-- Enable shared vision between teams (all teams are still COOP)
ENABLE_SHARED_TEAM_VISION = true

-- Enable map regrowth, see regrowth_map.lua for more info.
ENABLE_REGROWTH = true

-- Makes blueprint ghosts dissapear if they have been placed longer than this
GHOST_TIME_TO_LIVE = 3 * TICKS_PER_MINUTE -- set to 0 for infinite ghost life

--------------------------------------------------------------------------------
-- Spawn Options
--------------------------------------------------------------------------------

---------------------------------------
-- Starting Items
---------------------------------------
-- Items provided to the player the first time they join ("quick start" commented out)
PLAYER_SPAWN_START_ITEMS = {
    {name="submachine-gun", count=1},
    {name="piercing-rounds-magazine", count=600},
	{name="gun-turret", count=20},
    {name="burner-mining-drill", count = 2},
    {name="stone-furnace", count = 2},
    {name="iron-plate", count=20},
    {name="steel-axe", count=3},
	{name = "car", count=1},
	{name = "landfill", count=200}
}

-- Items provided after EVERY respawn (disabled by default)
PLAYER_RESPAWN_START_ITEMS = {
    -- {name="submachine-gun", count=1},
    -- {name="firearm-magazine", count=100}
}

---------------------------------------
-- Distance Options
---------------------------------------

-- This is the radius, in chunks, that a spawn area is from any other generated
-- chunks. It ensures the spawn area isn't too near generated/explored/existing
-- area. The larger you make this, the further away players will spawn from 
-- generated map area (even if it is not visible on the map!).
CHECK_SPAWN_UNGENERATED_CHUNKS_RADIUS = 50

-- Near Distance in chunks
NEAR_MIN_DIST = 25 --50
NEAR_MAX_DIST = 100 --125

-- Far Distance in chunks
FAR_MIN_DIST = 100 --50
FAR_MAX_DIST = 200 --125

---------------------------------------
-- Resource & Spawn Circle Options
---------------------------------------

-- Allow players to choose to spawn with a moat
SPAWN_MOAT_CHOICE_ENABLED = true

-- Create a circle of land area for the spawn
-- This is the radius (I think?) in TILES.
ENFORCE_LAND_AREA_TILE_DIST = 120

-- Start resource amounts (per tile/oil spot)
START_IRON_AMOUNT = 2400
START_COPPER_AMOUNT = 2200
START_STONE_AMOUNT = 3200
START_COAL_AMOUNT = 2100
START_URANIUM_AMOUNT = 1545
START_OIL_AMOUNT = 2000000

-- Start resource shape
-- If this is true, it will be a circle
-- If false, it will be a square
ENABLE_RESOURCE_SHAPE_CIRCLE = false

-- Start resource position and size
-- Position is relative to player starting location
-- x = right, left
-- y = up, down

START_RESOURCE_COAL_POS_X = -50
START_RESOURCE_COAL_POS_Y = -86
START_RESOURCE_COAL_SIZE = 30

START_RESOURCE_STONE_POS_X = 39
START_RESOURCE_STONE_POS_Y = -74
START_RESOURCE_STONE_SIZE = 17

START_RESOURCE_COPPER_POS_X = -58
START_RESOURCE_COPPER_POS_Y = -52
START_RESOURCE_COPPER_SIZE = 42

START_RESOURCE_IRON_POS_X = 14
START_RESOURCE_IRON_POS_Y = -52
START_RESOURCE_IRON_SIZE = 42

START_RESOURCE_URANIUM_POS_X = 14
START_RESOURCE_URANIUM_POS_Y = -74
START_RESOURCE_URANIUM_SIZE = 17 -- 0 Disabled by default.

WATER_SPAWN_OFFSET_X = -10
WATER_SPAWN_OFFSET_Y = -86
WATER_SPAWN_LENGTH = 14

-- Specify 3 oil spot locations
START_RESOURCE_OIL_A_POS_X = 15
START_RESOURCE_OIL_A_POS_Y = -86
START_RESOURCE_OIL_B_POS_X = 18
START_RESOURCE_OIL_B_POS_Y = -86
START_RESOURCE_OIL_C_POS_X = 21
START_RESOURCE_OIL_C_POS_Y = -86


-- Force the land area circle at the spawn to be fully grass
ENABLE_SPAWN_FORCE_GRASS = true

-- Set this to true for the spawn area to be surrounded by a circle of trees
SPAWN_TREE_CIRCLE_ENABLED = true

-- Set this to true for the spawn area to be surrounded by an octagon of trees
SPAWN_TREE_OCTAGON_ENABLED = false

---------------------------------------
-- Safe Spawn Area Options
---------------------------------------

-- Safe area has no aliens
-- +/- this in x and y direction
SAFE_AREA_TILE_DIST = CHUNK_SIZE*12

-- Warning area has reduced aliens
-- +/- this in x and y direction
WARNING_AREA_TILE_DIST = CHUNK_SIZE*25

-- 1 : X (spawners alive : spawners destroyed) in this area
WARN_AREA_REDUCTION_RATIO = 15


---------------------------------------
-- Other Forces/Teams Options
---------------------------------------

-- Separate teams
-- This allows you to join your own force/team. Everyone is still COOP/PvE, all
-- teams are friendly and cease-fire.
ENABLE_SEPARATE_TEAMS = false

-- Main force is what default players join
MAIN_FORCE = "Game"

-- The surface the game is called, for use with commands.
GAME_SURFACE_NAME="Game"

-- Enable if people can spawn at the main base
ENABLE_DEFAULT_SPAWN = false

-- Enable if people can allow others to join their base
ENABLE_SHARED_SPAWNS = true
MAX_ONLINE_PLAYERS_AT_SHARED_SPAWN = 3

-- Share local team chat with all teams
-- This makes it so you don't have to use /s
-- but it means you can't talk privately with your own team.
ENABLE_SHARED_TEAM_CHAT = true

---------------------------------------
-- Special Action Cooldowns
---------------------------------------
RESPAWN_COOLDOWN_IN_MINUTES = 60
RESPAWN_COOLDOWN_TICKS = TICKS_PER_MINUTE * RESPAWN_COOLDOWN_IN_MINUTES

-- Require playes to be online for at least 15 minutes
-- Else their character is removed and their spawn point is freed up for use
MIN_ONLIME_TIME_IN_MINUTES = 60
MIN_ONLINE_TIME = TICKS_PER_MINUTE * MIN_ONLIME_TIME_IN_MINUTES


--------------------------------------------------------------------------------
-- Alien Options
--------------------------------------------------------------------------------

-- Enable/Disable enemy expansion (Applies to RSO as well!)
ENEMY_EXPANSION = true

-- Divide the alien factors by this number to reduce it (or multiply if < 1)
ENEMY_POLLUTION_FACTOR_DIVISOR = 8
ENEMY_DESTROY_FACTOR_DIVISOR = 4


--------------------------------------------------------------------------------
-- Frontier Rocket Silo Options
--------------------------------------------------------------------------------

SILO_CHUNK_DISTANCE_X = 20
SILO_DISTANCE_X = SILO_CHUNK_DISTANCE_X*CHUNK_SIZE + CHUNK_SIZE/2
SILO_DISTANCE_Y = 20

-- Should be in the middle of a chunk
SILO_POSITION = {x = SILO_DISTANCE_X, y = SILO_DISTANCE_Y}

-- If this is enabled, the static position is ignored.
ENABLE_RANDOM_SILO_POSITION = true

--------------------------------------------------------------------------------
-- Long Reach Options
--------------------------------------------------------------------------------

BUILD_DIST_BONUS = 40
REACH_DIST_BONUS = BUILD_DIST_BONUS
RESOURCE_DIST_BONUS = 3

--------------------------------------------------------------------------------
-- Autofill Options
--------------------------------------------------------------------------------

AUTOFILL_TURRET_AMMO_QUANTITY = 10

--------------------------------------------------------------------------------
-- Use rso_config and rso_resource_config for RSO config settings
--------------------------------------------------------------------------------
-- Don't touch unless you know what you're doing...
-- When using RSO, all resources MUST BE SET TO SIZE=NONE!
--------------------------------------------------------------------------------
MAP_SETTINGS_RSO_TERRAIN_SEGMENTATION = "low" -- Frequency of water
MAP_SETTINGS_RSO_WATER = "very-high" -- Size of water patches
MAP_SETTINGS_RSO_PEACEFUL = false -- Peaceful mode for biters/aliens
MAP_SETTINGS_RSO_STARTING_AREA = "very-low" -- Does not affect Oarc spawn sizes.

-------------------------------------------------------------------------------
-- DEBUG
--------------------------------------------------------------------------------

-- DEBUG prints for me
global.oarcDebugEnabled = false
